Merge git://repo.or.cz/git-gui
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
ecda0723 3# git-submodules.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
f2dc06a3
PY
7USAGE="[--quiet] [--cached] \
8[add <repo> [-b branch]|status|init|update|summary [-n|--summary-limit <n>] [<commit>]] \
9[--] [<path>...]"
8f321a39 10OPTIONS_SPEC=
70c7ac22
LH
11. git-sh-setup
12require_work_tree
13
5c08dbbd 14command=
ecda0723 15branch=
70c7ac22
LH
16quiet=
17cached=
18
19#
20# print stuff on stdout unless -q was specified
21#
22say()
23{
24 if test -z "$quiet"
25 then
26 echo "$@"
27 fi
28}
29
ecda0723
SV
30# NEEDSWORK: identical function exists in get_repo_base in clone.sh
31get_repo_base() {
32 (
33 cd "`/bin/pwd`" &&
34 cd "$1" || cd "$1.git" &&
35 {
36 cd .git
37 pwd
38 }
39 ) 2>/dev/null
40}
41
f31a522a
ML
42# Resolve relative url by appending to parent's url
43resolve_relative_url ()
44{
45 branch="$(git symbolic-ref HEAD 2>/dev/null)"
46 remote="$(git config branch.${branch#refs/heads/}.remote)"
47 remote="${remote:-origin}"
48 remoteurl="$(git config remote.$remote.url)" ||
49 die "remote ($remote) does not have a url in .git/config"
50 url="$1"
51 while test -n "$url"
52 do
53 case "$url" in
54 ../*)
55 url="${url#../}"
56 remoteurl="${remoteurl%/*}"
57 ;;
58 ./*)
59 url="${url#./}"
60 ;;
61 *)
62 break;;
63 esac
64 done
65 echo "$remoteurl/$url"
66}
67
941987a5
LH
68#
69# Map submodule path to submodule name
70#
71# $1 = path
72#
73module_name()
74{
537601ac 75 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
4f2e94c0 76 re=$(printf '%s' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
537601ac
JH
77 name=$( GIT_CONFIG=.gitmodules \
78 git config --get-regexp '^submodule\..*\.path$' |
79 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
941987a5
LH
80 test -z "$name" &&
81 die "No submodule mapping found in .gitmodules for path '$path'"
82 echo "$name"
83}
33aa6fff
LH
84
85#
86# Clone a submodule
87#
23a485e3 88# Prior to calling, cmd_update checks that a possibly existing
ecda0723 89# path is not a git repository.
23a485e3 90# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
91# since it is the location of a new submodule.
92#
33aa6fff
LH
93module_clone()
94{
95 path=$1
96 url=$2
97
98 # If there already is a directory at the submodule path,
99 # expect it to be empty (since that is the default checkout
100 # action) and try to remove it.
101 # Note: if $path is a symlink to a directory the test will
102 # succeed but the rmdir will fail. We might want to fix this.
103 if test -d "$path"
104 then
105 rmdir "$path" 2>/dev/null ||
106 die "Directory '$path' exist, but is neither empty nor a git repository"
107 fi
108
109 test -e "$path" &&
110 die "A file already exist at path '$path'"
111
112 git-clone -n "$url" "$path" ||
941987a5 113 die "Clone of '$url' into submodule path '$path' failed"
33aa6fff
LH
114}
115
ecda0723
SV
116#
117# Add a new submodule to the working tree, .gitmodules and the index
118#
119# $@ = repo [path]
120#
121# optional branch is stored in global branch variable
122#
23a485e3 123cmd_add()
ecda0723 124{
5c08dbbd
JH
125 # parse $args after "submodule ... add".
126 while test $# -ne 0
127 do
128 case "$1" in
129 -b | --branch)
130 case "$2" in '') usage ;; esac
131 branch=$2
132 shift
133 ;;
134 -q|--quiet)
135 quiet=1
136 ;;
137 --)
138 shift
139 break
140 ;;
141 -*)
142 usage
143 ;;
144 *)
145 break
146 ;;
147 esac
148 shift
149 done
150
ecda0723
SV
151 repo=$1
152 path=$2
153
154 if test -z "$repo"; then
155 usage
156 fi
157
ecda0723
SV
158 # Guess path from repo if not specified or strip trailing slashes
159 if test -z "$path"; then
160 path=$(echo "$repo" | sed -e 's|/*$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
161 else
162 path=$(echo "$path" | sed -e 's|/*$||')
163 fi
164
5be60078 165 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
ecda0723
SV
166 die "'$path' already exists in the index"
167
d4264ca3
ML
168 # perhaps the path exists and is already a git repo, else clone it
169 if test -e "$path"
170 then
171 if test -d "$path/.git" &&
172 test "$(unset GIT_DIR; cd $path; git rev-parse --git-dir)" = ".git"
173 then
174 echo "Adding existing repo at '$path' to the index"
175 else
176 die "'$path' already exists and is not a valid git repo"
177 fi
178 else
179 case "$repo" in
180 ./*|../*)
181 # dereference source url relative to parent's url
182 realrepo="$(resolve_relative_url $repo)" ;;
183 *)
184 # Turn the source into an absolute path if
185 # it is local
186 if base=$(get_repo_base "$repo"); then
187 repo="$base"
188 fi
189 realrepo=$repo
190 ;;
191 esac
192
193 module_clone "$path" "$realrepo" || exit
194 (unset GIT_DIR; cd "$path" && git checkout -q ${branch:+-b "$branch" "origin/$branch"}) ||
195 die "Unable to checkout submodule '$path'"
196 fi
197
ecda0723
SV
198 git add "$path" ||
199 die "Failed to add submodule '$path'"
200
201 GIT_CONFIG=.gitmodules git config submodule."$path".path "$path" &&
202 GIT_CONFIG=.gitmodules git config submodule."$path".url "$repo" &&
203 git add .gitmodules ||
204 die "Failed to register submodule '$path'"
205}
206
70c7ac22 207#
211b7f19 208# Register submodules in .git/config
70c7ac22
LH
209#
210# $@ = requested paths (default to all)
211#
23a485e3 212cmd_init()
70c7ac22 213{
5c08dbbd
JH
214 # parse $args after "submodule ... init".
215 while test $# -ne 0
216 do
217 case "$1" in
218 -q|--quiet)
219 quiet=1
220 ;;
221 --)
222 shift
223 break
224 ;;
225 -*)
226 usage
227 ;;
228 *)
229 break
230 ;;
231 esac
232 shift
233 done
234
aadbe44f 235 git ls-files --stage -- "$@" | grep '^160000 ' |
70c7ac22
LH
236 while read mode sha1 stage path
237 do
211b7f19 238 # Skip already registered paths
941987a5 239 name=$(module_name "$path") || exit
5be60078 240 url=$(git config submodule."$name".url)
211b7f19 241 test -z "$url" || continue
70c7ac22 242
5be60078 243 url=$(GIT_CONFIG=.gitmodules git config submodule."$name".url)
70c7ac22 244 test -z "$url" &&
941987a5 245 die "No url found for submodule path '$path' in .gitmodules"
70c7ac22 246
f31a522a
ML
247 # Possibly a url relative to parent
248 case "$url" in
249 ./*|../*)
250 url="$(resolve_relative_url "$url")"
251 ;;
252 esac
253
5be60078 254 git config submodule."$name".url "$url" ||
941987a5 255 die "Failed to register url for submodule path '$path'"
70c7ac22 256
941987a5 257 say "Submodule '$name' ($url) registered for path '$path'"
70c7ac22
LH
258 done
259}
260
261#
211b7f19 262# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
263#
264# $@ = requested paths (default to all)
265#
23a485e3 266cmd_update()
70c7ac22 267{
5c08dbbd
JH
268 # parse $args after "submodule ... update".
269 while test $# -ne 0
270 do
271 case "$1" in
272 -q|--quiet)
273 quiet=1
274 ;;
275 --)
276 shift
277 break
278 ;;
279 -*)
280 usage
281 ;;
282 *)
283 break
284 ;;
285 esac
286 shift
287 done
288
aadbe44f 289 git ls-files --stage -- "$@" | grep '^160000 ' |
70c7ac22
LH
290 while read mode sha1 stage path
291 do
941987a5 292 name=$(module_name "$path") || exit
5be60078 293 url=$(git config submodule."$name".url)
211b7f19 294 if test -z "$url"
70c7ac22
LH
295 then
296 # Only mention uninitialized submodules when its
297 # path have been specified
298 test "$#" != "0" &&
941987a5 299 say "Submodule path '$path' not initialized"
211b7f19
LH
300 continue
301 fi
302
ba88a1fe 303 if ! test -d "$path"/.git -o -f "$path"/.git
211b7f19
LH
304 then
305 module_clone "$path" "$url" || exit
bf2d8246
LH
306 subsha1=
307 else
51884080 308 subsha1=$(unset GIT_DIR; cd "$path" &&
5be60078 309 git rev-parse --verify HEAD) ||
941987a5 310 die "Unable to find current revision in submodule path '$path'"
70c7ac22 311 fi
211b7f19 312
70c7ac22
LH
313 if test "$subsha1" != "$sha1"
314 then
51884080 315 (unset GIT_DIR; cd "$path" && git-fetch &&
70c7ac22 316 git-checkout -q "$sha1") ||
941987a5 317 die "Unable to checkout '$sha1' in submodule path '$path'"
70c7ac22 318
941987a5 319 say "Submodule path '$path': checked out '$sha1'"
70c7ac22
LH
320 fi
321 done
322}
323
bffe71f4
EM
324set_name_rev () {
325 revname=$( (
51884080 326 unset GIT_DIR
bffe71f4 327 cd "$1" && {
5be60078
JH
328 git describe "$2" 2>/dev/null ||
329 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
330 git describe --contains "$2" 2>/dev/null ||
331 git describe --all --always "$2"
bffe71f4
EM
332 }
333 ) )
334 test -z "$revname" || revname=" ($revname)"
335}
28f9af5d
PY
336#
337# Show commit summary for submodules in index or working tree
338#
339# If '--cached' is given, show summary between index and given commit,
340# or between working tree and given commit
341#
342# $@ = [commit (default 'HEAD'),] requested paths (default all)
343#
344cmd_summary() {
f2dc06a3 345 summary_limit=-1
d0f64dd4 346 for_status=
f2dc06a3 347
28f9af5d
PY
348 # parse $args after "submodule ... summary".
349 while test $# -ne 0
350 do
351 case "$1" in
352 --cached)
353 cached="$1"
354 ;;
d0f64dd4
PY
355 --for-status)
356 for_status="$1"
357 ;;
f2dc06a3
PY
358 -n|--summary-limit)
359 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
360 then
361 :
362 else
363 usage
364 fi
365 shift
366 ;;
28f9af5d
PY
367 --)
368 shift
369 break
370 ;;
371 -*)
372 usage
373 ;;
374 *)
375 break
376 ;;
377 esac
378 shift
379 done
bffe71f4 380
f2dc06a3
PY
381 test $summary_limit = 0 && return
382
28f9af5d
PY
383 if rev=$(git rev-parse --verify "$1^0" 2>/dev/null)
384 then
385 head=$rev
386 shift
387 else
388 head=HEAD
389 fi
390
391 cd_to_toplevel
392 # Get modified modules cared by user
393 modules=$(git diff-index $cached --raw $head -- "$@" |
394 grep -e '^:160000' -e '^:[0-7]* 160000' |
395 while read mod_src mod_dst sha1_src sha1_dst status name
396 do
397 # Always show modules deleted or type-changed (blob<->module)
398 test $status = D -o $status = T && echo "$name" && continue
399 # Also show added or modified modules which are checked out
400 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
401 echo "$name"
402 done
403 )
1cb639e6 404
d0f64dd4
PY
405 test -z "$modules" && return
406
1cb639e6
PY
407 git diff-index $cached --raw $head -- $modules |
408 grep -e '^:160000' -e '^:[0-7]* 160000' |
409 cut -c2- |
410 while read mod_src mod_dst sha1_src sha1_dst status name
411 do
412 if test -z "$cached" &&
413 test $sha1_dst = 0000000000000000000000000000000000000000
414 then
415 case "$mod_dst" in
416 160000)
417 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
418 ;;
419 100644 | 100755 | 120000)
420 sha1_dst=$(git hash-object $name)
421 ;;
422 000000)
423 ;; # removed
424 *)
425 # unexpected type
426 echo >&2 "unexpected mode $mod_dst"
427 continue ;;
428 esac
429 fi
430 missing_src=
431 missing_dst=
432
433 test $mod_src = 160000 &&
434 ! GIT_DIR="$name/.git" git-rev-parse --verify $sha1_src^0 >/dev/null 2>&1 &&
435 missing_src=t
436
437 test $mod_dst = 160000 &&
438 ! GIT_DIR="$name/.git" git-rev-parse --verify $sha1_dst^0 >/dev/null 2>&1 &&
439 missing_dst=t
bffe71f4 440
1cb639e6
PY
441 total_commits=
442 case "$missing_src,$missing_dst" in
443 t,)
444 errmsg=" Warn: $name doesn't contain commit $sha1_src"
445 ;;
446 ,t)
447 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
448 ;;
449 t,t)
450 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
451 ;;
452 *)
453 errmsg=
454 total_commits=$(
455 if test $mod_src = 160000 -a $mod_dst = 160000
456 then
457 range="$sha1_src...$sha1_dst"
458 elif test $mod_src = 160000
459 then
460 range=$sha1_src
461 else
462 range=$sha1_dst
463 fi
464 GIT_DIR="$name/.git" \
465 git log --pretty=oneline --first-parent $range | wc -l
466 )
eed35595 467 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
468 ;;
469 esac
470
471 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
472 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
473 if test $status = T
474 then
475 if test $mod_dst = 160000
476 then
477 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
478 else
479 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
480 fi
481 else
482 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
483 fi
484 if test -n "$errmsg"
485 then
486 # Don't give error msg for modification whose dst is not submodule
487 # i.e. deleted or changed to blob
488 test $mod_dst = 160000 && echo "$errmsg"
489 else
490 if test $mod_src = 160000 -a $mod_dst = 160000
491 then
f2dc06a3
PY
492 limit=
493 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 494 GIT_DIR="$name/.git" \
f2dc06a3 495 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
496 --first-parent $sha1_src...$sha1_dst
497 elif test $mod_dst = 160000
498 then
499 GIT_DIR="$name/.git" \
500 git log --pretty='format: > %s' -1 $sha1_dst
501 else
502 GIT_DIR="$name/.git" \
503 git log --pretty='format: < %s' -1 $sha1_src
504 fi
505 echo
506 fi
507 echo
d0f64dd4
PY
508 done |
509 if test -n "$for_status"; then
510 echo "# Modified submodules:"
511 echo "#"
512 sed -e 's|^|# |' -e 's|^# $|#|'
513 else
514 cat
515 fi
28f9af5d 516}
70c7ac22 517#
941987a5 518# List all submodules, prefixed with:
70c7ac22
LH
519# - submodule not initialized
520# + different revision checked out
521#
522# If --cached was specified the revision in the index will be printed
523# instead of the currently checked out revision.
524#
525# $@ = requested paths (default to all)
526#
23a485e3 527cmd_status()
70c7ac22 528{
5c08dbbd
JH
529 # parse $args after "submodule ... status".
530 while test $# -ne 0
531 do
532 case "$1" in
533 -q|--quiet)
534 quiet=1
535 ;;
536 --cached)
537 cached=1
538 ;;
539 --)
540 shift
541 break
542 ;;
543 -*)
544 usage
545 ;;
546 *)
547 break
548 ;;
549 esac
550 shift
551 done
552
aadbe44f 553 git ls-files --stage -- "$@" | grep '^160000 ' |
70c7ac22
LH
554 while read mode sha1 stage path
555 do
941987a5 556 name=$(module_name "$path") || exit
5be60078 557 url=$(git config submodule."$name".url)
ba88a1fe 558 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
70c7ac22
LH
559 then
560 say "-$sha1 $path"
561 continue;
562 fi
41c7c1bd 563 set_name_rev "$path" "$sha1"
70c7ac22
LH
564 if git diff-files --quiet -- "$path"
565 then
bffe71f4 566 say " $sha1 $path$revname"
70c7ac22
LH
567 else
568 if test -z "$cached"
569 then
51884080 570 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
41c7c1bd 571 set_name_rev "$path" "$sha1"
70c7ac22 572 fi
bffe71f4 573 say "+$sha1 $path$revname"
70c7ac22
LH
574 fi
575 done
576}
577
5c08dbbd
JH
578# This loop parses the command line arguments to find the
579# subcommand name to dispatch. Parsing of the subcommand specific
580# options are primarily done by the subcommand implementations.
581# Subcommand specific options such as --branch and --cached are
582# parsed here as well, for backward compatibility.
583
584while test $# != 0 && test -z "$command"
70c7ac22
LH
585do
586 case "$1" in
28f9af5d 587 add | init | update | status | summary)
5c08dbbd 588 command=$1
70c7ac22
LH
589 ;;
590 -q|--quiet)
591 quiet=1
592 ;;
ecda0723
SV
593 -b|--branch)
594 case "$2" in
595 '')
596 usage
597 ;;
598 esac
599 branch="$2"; shift
600 ;;
70c7ac22 601 --cached)
28f9af5d 602 cached="$1"
70c7ac22
LH
603 ;;
604 --)
605 break
606 ;;
607 -*)
608 usage
609 ;;
610 *)
611 break
612 ;;
613 esac
614 shift
615done
616
5c08dbbd
JH
617# No command word defaults to "status"
618test -n "$command" || command=status
619
620# "-b branch" is accepted only by "add"
621if test -n "$branch" && test "$command" != add
622then
ecda0723 623 usage
5c08dbbd
JH
624fi
625
28f9af5d
PY
626# "--cached" is accepted only by "status" and "summary"
627if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 628then
70c7ac22 629 usage
5c08dbbd
JH
630fi
631
632"cmd_$command" "$@"